## edu.stanford.nlp.optimization
Enum StochasticCalculateMethods

    java.lang.Object
      java.lang.Enum<StochasticCalculateMethods>
          edu.stanford.nlp.optimization.StochasticCalculateMethods

All Implemented Interfaces:
  Serializable, Comparable<StochasticCalculateMethods>

    public enum StochasticCalculateMethods

extends Enum<StochasticCalculateMethods>

This enumeratin was created to organize the selection of different methods for stochastic calculations. It was also created for use with Stochastic Meta Descent (SMDMinimizer) due to the need for Hessian Vector Products, and the inefficiency of continuing to calculate these vector products in other minimization methods like Stochastic Gradient Descent (SGDMinimizer)

Author:
  Alex Kleeman (akleeman@stanford.edu)

Enum Constant Summary
`AlgorithmicDifferentiation`
`ExternalFiniteDifference`
`GradientOnly`
`IncorporatedFiniteDifference`
`NoneSpecified`

Method Summary
`boolean` `calculatesHessianVectorProduct()`
`static StochasticCalculateMethods` `parseMethod(String method)`
`static StochasticCalculateMethods` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static StochasticCalculateMethods[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

Methods inherited from class java.lang.Enum
`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Enum Constant Detail

### NoneSpecified

    public static final StochasticCalculateMethods NoneSpecified

### GradientOnly

    public static final StochasticCalculateMethods GradientOnly

### AlgorithmicDifferentiation

    public static final StochasticCalculateMethods AlgorithmicDifferentiation

### IncorporatedFiniteDifference

    public static final StochasticCalculateMethods IncorporatedFiniteDifference

### ExternalFiniteDifference

    public static final StochasticCalculateMethods ExternalFiniteDifference

Method Detail

### values

    public static StochasticCalculateMethods[] values()

  Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

      for (StochasticCalculateMethods c : StochasticCalculateMethods.values())
          System.out.println(c);

  Returns:
    an array containing the constants of this enum type, in the order they are declared

### valueOf

    public static StochasticCalculateMethods valueOf(String name)

  Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

  Parameters:
    `name` - the name of the enum constant to be returned.
  Returns:
    the enum constant with the specified name
  Throws:
    `IllegalArgumentException` - if this enum type has no constant with the specified name
    `NullPointerException` - if the argument is null

### calculatesHessianVectorProduct

    public boolean calculatesHessianVectorProduct()

### parseMethod

    public static StochasticCalculateMethods parseMethod(String method)

Stanford NLP Group